#!/usr/bin/perl
use strict;
use warnings;

my $mpileup_row = $ARGV[0];

my $mpileup_filtered = $ARGV[1];

my $list_filtered = $ARGV[2];

my $blast_filtered = $ARGV[3];


print "\nMPILEUP row\n";
open(MPR, $mpileup_row) or die ("Can't open $mpileup_row\n");
my $basecovered=0;
my $nbvariant=0;
while (my $line=<MPR>){
	my @fields = split(/\s+/,$line);
	if ($#fields >= 4){
		$basecovered++;
		my $match = $fields[4];
		$match =~ s/\$//g; #the read start at this position
		$match =~ s/\^.//g; #the read end at this position followed by quality char
		if ($match =~/[ACGTNacgtn]+/){
			$nbvariant++;
		}
	}
	else {
		#print STDERR "Erreur : $line\n";
	}
}

print "Base covered :\t$basecovered\n";
print "Variant detected :\t$nbvariant\n";
close (MPR);

print "\nMPILEUP filered\n";
open(MPF, $mpileup_filtered) or die ("Can't open $mpileup_filtered\n");

$basecovered=0;
$nbvariant=0;
while (my $line=<MPF>){
	my @fields = split(/\s+/,$line);
	if ($#fields >= 4){
		$basecovered++;
		my $match = $fields[4];
		$match =~ s/\$//g; #the read start at this position
		$match =~ s/\^.//g; #the read end at this position followed by quality char
		if ($match =~/[ACGTNacgtn]+/){
			$nbvariant++;
		}
	}
	else {
		#print STDERR "Erreur : $line\n";
	}
}

print "Variant selected :\t$nbvariant\n";
close (MPF);

print "\nMPILEUP filered without dubious position\n";
open(LF, $list_filtered) or die ("Can't open $list_filtered\n");
$nbvariant=0;
while (my $line=<LF>){
	$nbvariant++;
}

print "Variant selected :\t$nbvariant\n";
close (LF);

print "\nMPILEUP filered without dubious position and BLAST\n";
open(BF, $blast_filtered) or die ("Can't open $blast_filtered\n");
$nbvariant=0;
while (my $line=<BF>){
	$nbvariant++;
}

print "Variant selected :\t$nbvariant\n";
close (BF);










