#!/usr/bin/perl
use strict;
use warnings;

my $read1_row = $ARGV[0];
my $read2_row = $ARGV[1];

my $read1_trimmed = $ARGV[2];
my $read2_trimmed = $ARGV[3];

my $read1_trimmed_noN = $ARGV[4];
my $read2_trimmed_noN = $ARGV[5];

my $sam_row = $ARGV[6];

my $sam_filtered = $ARGV[7];





open(INR1R, $read1_row) or die ("Can't open $read1_row\n");
my $nbread=0;
my $nbbase =0;
while (my $line1=<INR1R>){
	my $line2 = <INR1R>;
	my $line3 = <INR1R>;
	my $line4 = <INR1R>;
	if ($line1 =~ /^@/){
		$nbread++;
		if ($line2=~/([ATGCNX]+)/i){
			$nbbase += length($1);
		}
	}
}
print "Row Reads 1\t\tNumber of reads : ",$nbread,"\tnumber of bases : ",$nbbase,"\n";
close (INR1R);

open(INR2R, $read2_row) or die ("Can't open $read2_row\n");
$nbread=0;
$nbbase =0;
while (my $line1=<INR2R>){
	my $line2 = <INR2R>;
	my $line3 = <INR2R>;
	my $line4 = <INR2R>;
	if ($line1 =~ /^@/){
		$nbread++;
		if ($line2=~/([ATGCNX]+)/i){
			$nbbase += length($1);
		}
	}
}
print "Row Reads 2\t\tNumber of reads : ",$nbread,"\tnumber of bases : ",$nbbase,"\n";
close (INR2R);

open(INR1T, $read1_trimmed) or die ("Can't open $read1_trimmed\n");
$nbread=0;
$nbbase =0;
while (my $line1=<INR1T>){
	my $line2 = <INR1T>;
	my $line3 = <INR1T>;
	my $line4 = <INR1T>;
	if ($line1 =~ /^@/){
		$nbread++;
		if ($line2=~/([ATGCNX]+)/i){
			$nbbase += length($1);
		}
		else {
			print STDERR "$line1\n$line2\n";
		}
	}
}
print "Trimmed Reads 1\t\tNumber of reads : ",$nbread,"\tnumber of bases : ",$nbbase,"\n";
close (INR1T);

open(INR2T, $read2_trimmed) or die ("Can't open $read2_trimmed\n");
$nbread=0;
$nbbase =0;
while (my $line1=<INR2T>){
	my $line2 = <INR2T>;
	my $line3 = <INR2T>;
	my $line4 = <INR2T>;
	if ($line1 =~ /^@/){
		$nbread++;
		if ($line2=~/([ATGCNX]+)/i){
			$nbbase += length($1);
		}
		else {
			print STDERR "$line1\n$line2\n";
		}
	}
}
print "Trimmed Reads 2\t\tNumber of reads : ",$nbread,"\tnumber of bases : ",$nbbase,"\n";
close (INR2T);

open(INR1N, $read1_trimmed_noN) or die ("Can't open $read1_trimmed_noN\n");
$nbread=0;
$nbbase =0;
while (my $line1=<INR1N>){
	my $line2 = <INR1N>;
	my $line3 = <INR1N>;
	my $line4 = <INR1N>;
	if ($line1 =~ /^@/){
		$nbread++;
		if ($line2=~/([ATGCNX]+)/i){
			$nbbase += length($1);
		}
		else {
			print STDERR "$line1\n$line2\n";
		}
	}
}
print "Trimmed (no N) Reads 1\tNumber of reads : ",$nbread,"\tnumber of bases : ",$nbbase,"\n";
close (INR1N);

open(INR2N, $read2_trimmed_noN) or die ("Can't open $read2_trimmed_noN\n");
$nbread=0;
$nbbase =0;
while (my $line1=<INR2N>){
	my $line2 = <INR2N>;
	my $line3 = <INR2N>;
	my $line4 = <INR2N>;
	if ($line1 =~ /^@/){
		$nbread++;
		if ($line2=~/([ATGCNX]+)/i){
			$nbbase += length($1);
		}
		else {
			print STDERR "$line1\n$line2\n";
		}
	}
}
print "Trimmed (no N) Reads 2\tNumber of reads : ",$nbread,"\tnumber of bases : ",$nbbase,"\n";
close (INR2N);

print "\nSAM row\n";
open(SAM, $sam_row) or die ("Can't open $sam_row\n");
my %bitscore;
while (my $line=<SAM>){
	if (($line !~ /^\@SQ/)&&($line !~ /^\@PG/)){
		my @fields = split(/\s+/,$line);
		my $bit = $fields[1];
		if ($bitscore{$bit}){
			$bitscore{$bit}++;
		}
		else {
			$bitscore{$bit}=1;
		}
	}
}

print "bitscore\t";
foreach my $key (sort {$bitscore{$b} <=> $bitscore{$a}} keys %bitscore) {
	print $key,"\t*\t";
}
print "\n";

print " number \t";
foreach my $key (sort {$bitscore{$b} <=> $bitscore{$a}} keys %bitscore) {
	print $bitscore{$key},"\t*\t";
}
print "\n";
close (SAM);

print "\nSAM filtered\n";
open(SAMF, $sam_filtered) or die ("Can't open $sam_filtered\n");
undef %bitscore;
while (my $line=<SAMF>){
	if (($line !~ /^\@SQ/)&&($line !~ /^\@PG/)){
		my @fields = split(/\s+/,$line);
		my $bit = $fields[1];
		if ($bitscore{$bit}){
			$bitscore{$bit}++;
		}
		else {
			$bitscore{$bit}=1;
		}
	}
}

print "bitscore\t";
foreach my $key (sort {$bitscore{$b} <=> $bitscore{$a}} keys %bitscore) {
	print $key,"\t*\t";
}
print "\n";

print " number \t";
foreach my $key (sort {$bitscore{$b} <=> $bitscore{$a}} keys %bitscore) {
	print $bitscore{$key},"\t*\t";
}
print "\n";
close (SAMF);

